#!/bin/sh 
# setup.sh
# Copyright Fujitsu Limited 2004-2012
# All Right Reserved

ciph_cmd="/opt/FJSVhrmcp/bin/cipher_proxy.sh"
common_ini="/var/opt/FJSVhrm/config/common.ini"
HRM_bin=/opt/FJSVhrm/bin export HRM_bin
HRM_config=/var/opt/FJSVhrm/config export HRM_config
HRM_data=/var/opt/FJSVhrm/data export HRM_data
HRM_log=/var/opt/FJSVhrm/log export HRM_log
HRM_temp=/var/opt/FJSVhrm/temp export HRM_temp
hrmcmd="/opt/FJSVhrm/bin/hrmcommand -t 90"		# sdb resource test takes 90 secs
cipher_path="/opt/FJSVhrmcp/bin/jre/bin/java"
cipher_status_file="/var/opt/FJSVhrmcp/log/cipherproxy_startstatus.log"
hrm_pid_file="/var/opt/FJSVhrm/log/sched.pid"

if [ -f "$HRM_config/server_type" ]
then
	HRM_PLATFORM=`cat "$HRM_config/server_type"`
else
	HRM_PLATFORM="PG"  # default PG
fi
export HRM_PLATFORM

solaris=0					

if [ "$solaris" -eq 0 ]
then
	id_command="/usr/bin/id"				# linux
	p="echo -e"						# linux
else
	id_command="/usr/xpg4/bin/id"				# solaris
	p="echo"						# solaris
fi


#begin
	msg000="=================================================="
	msg001="==== HRM Setup Menu ===="
	msg002="Current Status: "
	msg003="HRM is disabled."
	msg004="HRM is not running."
	msg005="HRM is running."
	msg006="HRM is starting."
	msg007="==== HRM Setup Menu (PSA mode) ===="
	msg008="==== HRM Setup Menu (ServerView mode) ===="
	msg009="reserve"
	msg010="Select a number: "
	msg011=" 1    Enable HRM"
	msg012=" 2    Disable HRM"
	msg013=" 3    Start HRM"
	msg014=" 4    Stop HRM"
	msg015=" 5    SDB Agent Setting Menu"
	msg016=" 6    Security Setting Menu"
	msg017=" 7    HRM Log Snap Menu"
	msg018=" 8    SNMP Community Setting Menu"
	msg019=" 9    HRM Statistics Setting Menu"
	msg020="10    MMB IP address Setting Menu"
	msg021="reserve"
	msg022="reserve"
	msg023=" q    Quit"
	msg024="Current settings:"
	msg025="reserve"
	msg026="enable"
	msg027="disable"
	msg028="unconfigured"
	msg029="not running"
	msg030="running"
	msg031="configured"
	msg032="error"
	msg033="[Press Enter]"
	msg034="Apply these changes?"
	msg035="Applied."
	msg036="Canceled."
	msg037="Wait a moment."
	msg038="This command should be run by root user."
	msg039="ServerView Rpm Check"
	msg040="reserve"
	msg041="reserve"
	msg042="cipherproxy is running."
	msg043="cipherproxy is stopped."
	msg044="cipherproxy is stopped with error."

	msg100="Enable HRM ?"
	msg101="HRM is enabled."
	msg102="Disable HRM ?"
	msg103="HRM is disabled."
	msg104="HRM is running. Stop HRM before disable."

	msg111="Are you sure to start HRM now?"
	msg112="Please restart HRM manually to reflect the changes of settings."
	msg113="HRM is started."
	msg114="reserve"
	msg115="Are you sure to restart HRM now?"
	msg116="HRM is restarted."
	msg117="Are you sure to stop HRM?"
	msg118="HRM is stopped."
	msg119="HRM is starting. Stop HRM before disable."

	msg130="==== Security Setting Menu ===="
	msg131="Client Authentication Password  : "
	msg132="Client Communication Encryption : "
	msg133=" 1    Set Authentication Password."
	msg134=" 2    Remove Authentication Password."
	msg135=" 3    Enable Encrypt Client Communication."
	msg136=" 4    Disable Encrypt Client Communication."
	msg137=" b    Back"
	msg138="Authentication password is already set. Do you overwrite?"
	msg139="Authentication password is not set."
	msg140="Remove the authencation password?"
	msg141="removed."
	msg142="cipherproxy is not installed."
	msg143="succeed."
	msg144="failed."
	msg145="Caution:There is a possibility for it to become impossible to communicate\n when the communication encryption setting is changed."

	msg160="==== SNMP Community Setting Menu ===="
	msg161="PSA SNMP Community              : "
	msg162="ServerView SNMP Community       : "
	msg163="Management Board SNMP Community : "
	msg164="Management Blade SNMP Community : "
	msg165=" 1    Change PSA SNMP Community"
	msg166=" 1    Change ServerView SNMP Community"
	msg167=" 2    Check PSA SNMP Community"
	msg168=" 2    Check ServerView SNMP Community"
	msg169=" 3    Change Management Board SNMP Community"
	msg170=" 3    Change Management Blade SNMP Community"
	msg171=" 4    Check Management Board SNMP Community"
	msg172=" 4    Check Management Board SNMP Community"
	msg173=" b    Back"
	msg174="Enter the PSA SNMP Community."
	msg175="Enter the ServerView SNMP Community."
	msg176="(empty: auto detection, c: cancel) : "
	msg177="Enter the Management Board SNMP Community."
	msg178="Enter Management Blade SNMP Community. "
	msg179="(empty, c: cancel) : "
	msg180="ERROR: failed to SNMP community check."

	msg200="==== HRM Log Snap Menu ===="
	msg201=" 1     Run InstallChecker."
	msg202=" 2     Collecting data as HRM Snap."
	msg203=" 3     Show HRM Snap file list."
	msg204=" 4     Delete HRM Snap file."
	msg205=" b     Back"
	msg206="Wait a moment."
	msg207="Finished. The snap file is above."
	msg208="There are following HRM snap files."
	msg209="There is no HRM snap file."
	msg210="Enter name of HRM snap file. : "
	msg211="Collect HRM snap ?"
	msg212="deleted."

	msg230="==== HRM Statistics Setting Menu ===="
	msg231="Collecting Statistical Information from Management Board : "
	msg235=" 1    Enable to Collect Statistical Information from Management Board"
	msg236=" 2    Disable to Collect Statistical Information from Management Board"
	msg237=" b    Back"

	msg240="[Current Setting]"
	msg241="MMB IP Address         : "
	msg242="Do you want to change the MMB IP Address? [y,n?]: "
	msg243="Please input MMB IP Address.                    : "
	msg244="Error:The character string is too long."
	msg245="Error: Please input the character."
	msg246="Input IP address is abnormal."
	msg247="[New Setting]"
	msg248="Do you apply the New Setting? [y,n?]: "
	msg249="MMB IP Address was changed."
#end

#------------------------------------------------------------
#
# determine the message file
#
base=`echo "$0" | sed "s/\.sh//"`

#
# load messages
#
if [ X"$1" = X"-e" ]; then
	LANG=C
fi
case "$LANG" in
ja_JP.eucJP|ja_JP.eucjp)        pass_lang="";   sdb_lang="-j euc";  . ${base}.ja_JP.eucJP;;
ja_JP.UTF-8|ja_JP.utf8)         pass_lang="-u"; sdb_lang="-j utf8"; . ${base}.ja_JP.UTF-8;;
*)                              pass_lang="-e"; sdb_lang="-e";;
esac

#
# define functions
#
press_enter()
{
	$p "$msg033"
	read dummy
}

# check that current user is root
root_check()
{
	uid=`$id_command -un 2>/dev/null`
	if [ "$uid" != "root" ]
	then
		$p "$msg038"
		exit 1
	fi
}

# check package type
server_type_check()
{
	server_type=""
	if [ -f /var/opt/FJSVhrm/config/server_type ]
	then
		server_type=`cat /var/opt/FJSVhrm/config/server_type`
	fi
}


# print a prompt and ask yes or no
# return 0 if Y or y
# return 1 if N or n
ask_y_or_n()
{
	prompt_str=$1
	while :
	do
		$p "$prompt_str [y or n]: \c"
		read x
		if [ "$x" = "y" -o "$x" = "Y" ]
		then
			r=0
			break
		fi
		if [ "$x" = "n" -o "$x" = "N" ]
		then
			r=1
			break
		fi
	done
	return $r
}

# check hrm process (hrmsched)
check_hrm_process()
{
	hrmpid=`/bin/ps -eo pid,args | /bin/grep -v grep | /bin/grep -w 'hrmsched' | /usr/bin/awk '{print $1}'`
	fjsvhrmpid=`/bin/ps -eo pid,args | /bin/grep -v grep | /bin/grep -w 'FJSVhrm mstart' | /usr/bin/awk '{print $1}'`
	hrmgetpid=`/bin/ps -eo pid,args | /bin/grep -v grep | /bin/grep -w '/opt/FJSVhrm/bin/get SERVER_AGENT_READY' | /usr/bin/awk '{print $1}'`
	cippid=`/bin/ps -eo pid,args | /bin/grep -v grep | /bin/grep "$cipher_path" | /usr/bin/awk '{print $1}'`
}


# show title bar 
banner()
{
	tput clear
	$p ""
	n=`expr "$1" : ".*"`
	n=`expr \( 76 - $n \) / 2`
	if [ $n -gt 40 ]; then n=40; fi
	if [ $n -lt  0 ]; then n=0; fi
	space=`echo "                                           " | cut -c 1-$n`
	tput rev
	$p "$space$1$space"
	tput rmso
}

xbanner()
{
	echo "$1"
}


#
# serverview rpm check
# 0: OK   1: NG
#
serverview_rpm_check()
{
	if [ "$server_type" != "PG" -a "$server_type" != "PQ" ]; then
		return 0
	fi

	$p ""
	$p "$msg039"
	$p ""

	printf "srvmagt-agents install check : "
	if /bin/rpm -q srvmagt-agents > /dev/null 2>&1
	then
		svag_rpm=1
		printf "OK\n"
	else
		svag_rpm=0
		printf "NG\n"
	fi

	$p ""
	press_enter

	if [ $svag_rpm -eq 1 ]; then
		return 0
	else
		return 1
	fi
}

#
# hrm status for title menu
#
show_hrm_status()
{
	# HRM
	if [ ! -f "$HRM_data/hrm_agent_enabled" ]
	then
		$p "    $msg003"
	elif [ -n "$hrmpid" ]
	then
		$p "    $msg005"
	elif [ -n "$hrmgetpid" -o -n "$fjsvhrmpid" ]
	then
		$p "    $msg006"
	else
		$p "    $msg004"
	fi

	# cipher
	cipher_ok=0
	cipher_ng=0
	if [ -n "$cippid" ] ; then
		cipher_ok=1
	fi

	if [ -n "$hrmpid" ] ; then
		if [ ! -n "$cippid" ] ; then
			if [ "$cipher_status_file" -nt "$hrm_pid_file" ] ; then
				if grep -i error "$cipher_status_file" >/dev/null ; then
					cipher_ng=1
				fi
			fi
		fi
	fi
#	if [ "$cipher_ok" = 1 ]
#	then
#		$p "    $msg042"
#	fi
	if [ "$cipher_ng" = 1 ]
	then
		$p "    $msg044"
	fi
}

restart_service()
{
	check_hrm_process
	# hrmsched or FJSVhrm or get SERVER_AGENT_READY is not running
	if [ ! -n "$hrmpid" -a ! -n "$hrmgetpid" -a ! -n "$fjsvhrmpid" ]
	then
		return			# no need to restart
	fi

	if ask_y_or_n "$msg115"
	then
		check_hrm_process
		if [ -n "$fjsvhrmpid" ]
		then
			kill -TERM $fjsvhrmpid >/dev/null 2>&1
		fi
		check_hrm_process
		if [ -n "$hrmgetpid" ]
		then
			kill -TERM $hrmgetpid >/dev/null 2>&1
			sleep 5
		fi
		/opt/FJSVhrm/bin/hrmstop >/dev/null 2>&1
		sleep 2
		/opt/FJSVhrm/bin/hrmstart >/dev/null 2>&1
		sleep 5
		$p "$msg116"
	else
		$p "$msg112"
	fi
	press_enter
}


set_sec_comm()
{
        if [ -f /var/opt/FJSVhrm/data/password ]
        then
                sec_auth="enable"
        else
                sec_auth="disable"
        fi

	mmb_comm=""
	if [ -f  "$common_ini" ]
	then
		if [ "$server_type" != "SR" -a "$server_type" != "PQ" ]; then
			mmb_comm=`grep "^MB_COMMUNITY=" $common_ini | head -1 | sed "s/^MB_COMMUNITY=//"`
		else
			mmb_comm=`grep "^MMB_COMMUNITY=" $common_ini | head -1 | sed "s/^MMB_COMMUNITY=//"`
		fi
	fi

	if [ "$server_type" = "SR" ]; then
		psa_comm=""
		if [ -f  "$common_ini" ]
		then
			psa_comm=`grep "^PSA_COMMUNITY=" $common_ini | head -1 | sed "s/^PSA_COMMUNITY=//"`
		fi
		if [ -x /opt/FJSVhrm/bin/psa_community ]
		then
			c=`/opt/FJSVhrm/bin/psa_community`
			if [ $? = 0 ] ; then
				psa_comm="$c(auto)"
			else
				psa_comm="$c(manual)"
			fi
		fi
	else
		sv_comm=""
		if [ -f  "$common_ini" ]
		then
			sv_comm=`grep "^SV_COMMUNITY=" $common_ini | head -1 | sed "s/^SV_COMMUNITY=//"`
		fi
		if [ -x /opt/FJSVhrm/bin/sv_community ]
		then
			c=`/opt/FJSVhrm/bin/sv_community`
			if [ $? = 0 ] ; then
				sv_comm="$c(auto)"
			else
				sv_comm="$c(manual)"
			fi
		fi
	fi
}



#
# SNMP menu
#
hrm_snmp_menu()
{
	if [ "$server_type" != "PG" -a "$server_type" != "SR" -a "$server_type" != "PQ" ]; then
		return 0
	fi

	while :
	do
		set_sec_comm
		need_restart=0
		#tput clear
		banner "$msg160"
		$p ""
		$p "$msg024"
		if [ "$server_type" = "SR" -o "$server_type" = "PQ" ]; then
			if [ "$server_type" = "SR" ]; then
				$p "    $msg161" "$psa_comm"
			else
				$p "    $msg162" "$sv_comm"
			fi
			$p "    $msg163" "$mmb_comm"
		else
			$p "    $msg162" "$sv_comm"
			$p "    $msg164" "$mmb_comm"
		fi
		$p ""
		if [ "$server_type" = "SR" ]; then
			$p "$msg165"
			$p "$msg167"
		else
			$p "$msg166"
			$p "$msg168"
		fi
		if [ "$server_type" = "SR" -o "$server_type" = "PQ" ]; then
			$p "$msg169"
			$p "$msg171"
		else
			$p "$msg170"
			$p "$msg172"
		fi
		$p "$msg173"
		$p ""
		$p "$msg010\c"
		read num
		case "$num" in
		1)
			if [ "$server_type" = "SR" ]; then
				$p "$msg174"
			else
				$p "$msg175"
			fi
			$p "$msg176""\c"
			read comm
			if [ "$comm" = "c" ]
			then
				$p "$msg036"	# cancel
			else
				ini="$common_ini"
				tmp="/tmp/hrm_tmp.$$"
				if [ "$server_type" = "SR" ]; then
					sed "s/^PSA_COMMUNITY=.*/PSA_COMMUNITY=$comm/" $ini > $tmp
				else
					sed "s/^SV_COMMUNITY=.*/SV_COMMUNITY=$comm/" $ini > $tmp
				fi
				if [ $? = 0 -a -s "$tmp" ]
				then
					cp $tmp $ini
					need_restart=1
					$p "$msg035"	# applied
				fi
				rm -f $tmp
			fi
			;;
		2)
			if [ "$server_type" = "SR" ]; then
				/opt/FJSVhrm/bin/get PSA_INFO
			else
				/opt/FJSVhrm/bin/get SVA_INFO
			fi
			if [ $? != 0 ]
			then
				$p "$msg180"	# failed
			fi
			;;
		3)
			if [ "$server_type" = "SR" -o "$server_type" = "PQ" ]; then
				$p "$msg177"
			else
				$p "$msg178"
			fi
			$p "$msg179""\c"
			read comm
			if [ "$comm" = "" -o "$comm" = "c" ]
			then
				$p "$msg036"	# cancel
			else
				ini="$common_ini"
				tmp="/tmp/hrm_tmp.$$"
				if [ "$server_type" = "SR" -o "$server_type" = "PQ" ]; then
					sed "s/^MMB_COMMUNITY=.*/MMB_COMMUNITY=$comm/" $ini > $tmp
				else
					sed "s/^MB_COMMUNITY=.*/MB_COMMUNITY=$comm/" $ini > $tmp
				fi
				if [ $? = 0 -a -s "$tmp" ]
				then
					cp $tmp $ini
					need_restart=1
					$p "$msg035"	# applied
				fi
				rm -f $tmp
			fi
			;;
		4)
			if [ "$server_type" = "SR" -o "$server_type" = "PQ" ]; then
				/opt/FJSVhrm/bin/get MMB_INFO
			else
				/opt/FJSVhrm/bin/get MB_INFO
			fi
			if [ $? != 0 ]
			then
				$p "$msg180"	failed
			fi
			;;
		b|B|q|Q)
			return
		esac
		press_enter

		if [ "$need_restart" = 1 ]
		then
			restart_service
		fi
	done
}




set_cipher_settings()
{
        sec_ciph="disable"
        if [ -x $ciph_cmd ]
        then
                if $ciph_cmd status | grep '^cryptmode=1' >/dev/null
                then
                        sec_ciph="enable"
                else
                        sec_ciph="disable"
                fi
        fi

	if [ -f /var/opt/FJSVhrm/data/password ]
	then
        	hrm_ciph="enable"
	else
		hrm_ciph="disable"
	fi

}


#
# security menu
#
hrm_security_menu()
{
	while :
	do
		set_cipher_settings
		need_restart=0
		#tput clear
		banner "$msg130"
		$p ""
		$p "$msg145"
		$p ""
		$p "$msg002"
		$p "    $msg131" "$hrm_ciph"
		$p "    $msg132" "$sec_ciph"
		$p ""
		$p "$msg133"
		$p "$msg134"
		$p "$msg135"
		$p "$msg136"
		$p "$msg137"
		$p ""
		$p "$msg010\c"
		read num
		case "$num" in
		1)
			ok=0
			if [ -f /var/opt/FJSVhrm/data/password ]
			then
				if ask_y_or_n "$msg138"
				then
					ok=1
				fi
			else
				ok=1
			fi

			if [ "$ok" = 1 ]
			then
				/opt/FJSVhrm/bin/hrmpasswd $pass_lang
				if [ $? = 0 ]
				then
					need_restart=1
				fi
			fi
			;;

		2)
			if [ ! -f /var/opt/FJSVhrm/data/password ]
			then
				$p "$msg139"
			else
				if ask_y_or_n "$msg140"
				then
					rm -f /var/opt/FJSVhrm/data/password && $p "$msg141"
					need_restart=1
				fi
			fi
			;;

		3)
			if [ -x $ciph_cmd ]
			then
				$ciph_cmd cryptenable
				if [ $? = 0 ]
				then
					$p "$msg143"
				else
					$p "$msg144"
				fi
				need_restart=1
			else
				$p "$msg142"
			fi
			;;
		4)
			if [ -x $ciph_cmd ]
			then
				$ciph_cmd cryptdisable
				if [ $? = 0 ]
				then
					$p "$msg143"
				else
					$p "$msg144"
				fi
				need_restart=1
			else
				$p "$msg142"
			fi
			;;
		b|B|q|Q)
			return
		esac
		press_enter

		if [ "$need_restart" = 1 ]
		then
			restart_service
		fi
	done
}



#
# HRM snap menu
#
hrm_snap_menu()
{
	while :
	do
		need_restart=0
		#tput clear
		banner "$msg200"
		$p ""
		$p "$msg201"
		$p "$msg202"
		$p "$msg203"
		$p "$msg204"
		$p "$msg205"
		$p ""
		$p "$msg010\c"
		read num
		case "$num" in
		1)	/opt/FJSVhrm/bin/hrm_install_check.sh
			;;
		2)	if ask_y_or_n "$msg211"
			then
				$p "$msg206"
				/opt/FJSVhrm/bin/hrmsnap.sh
				$p "$msg207"
			fi
			;;
		3)	n=`/opt/FJSVhrm/bin/hrmsnap.sh list |wc -l`
			if [ "$n" -eq 0 ]
			then
				$p "$msg209"
			else
				$p "$msg208"
				$p "directory: /var/opt/FJSVhrm/temp/hrmsnap/"
				/opt/FJSVhrm/bin/hrmsnap.sh list | awk '{print $1, $3, "byte"}'
			fi
			;;
		4)	n=`/opt/FJSVhrm/bin/hrmsnap.sh list |wc -l`
			if [ "$n" -eq 0 ]
			then
				$p "$msg209"
			else
				$p "$msg208"
				/opt/FJSVhrm/bin/hrmsnap.sh list | awk '{print $1, $3, "byte"}'
				$p "$msg210""\c"
				read name
				if [ "$name" != "" ]
				then
					/opt/FJSVhrm/bin/hrmsnap.sh delete "$name" >/dev/null 2>/dev/null && $p "$msg212"
				fi
			fi
			;;
		b|B|q|Q)
			return
		esac
		press_enter
	done
}



#
# MMB's statistics menu
#
hrm_statistics_menu()
{
	if [ "$server_type" != "SR" -a "$server_type" != "PQ" ]; then
		return 0
	fi

	while :
	do
		# check MMB statistics
		stat_status="disable"
		if grep "^FAN=1" "$common_ini" >/dev/null 
		then
			stat_status="enable"
		fi
		if grep "^TEMP=1" "$common_ini" >/dev/null 
		then
			stat_status="enable"
		fi
		if grep "^VOLT=1" "$common_ini" >/dev/null 
		then
			stat_status="enable"
		fi

		banner "$msg230"
		$p ""
		$p "$msg024"
		$p "    $msg231" "$stat_status"
		$p ""
		$p "$msg235"
		$p "$msg236"
		$p "$msg237"
		$p ""
		$p "$msg010\c"
		read num
		case "$num" in
		1)						# enable
			ini="$common_ini"
			tmp="/tmp/hrm_tmp.$$"
			sed -e "s/^FAN=.*/FAN=1/" -e "s/^TEMP=.*/TEMP=1/" -e "s/^VOLT=.*/VOLT=1/" $ini > $tmp
			if [ $? = 0 -a -s "$tmp" ]
			then
				cp $tmp $ini
				$p "$msg035"    # applied
			fi
			rm -f $tmp
			;;

		2)						# disable
			ini="$common_ini"
			tmp="/tmp/hrm_tmp.$$"
			sed -e "s/^FAN=.*/FAN=0/" -e "s/^TEMP=.*/TEMP=0/" -e "s/^VOLT=.*/VOLT=0/" $ini > $tmp
			if [ $? = 0 -a -s "$tmp" ]
			then
				cp $tmp $ini
				$p "$msg035"    # applied
			fi
			rm -f $tmp
			;;
		b|B|q|Q)
			return
		esac
		press_enter
	done
}

#
# MMB's IP address setting menu
#
update_mmb_ip()
{
	# Get Current MMB IP address
	mmb_ip=`awk -F = '/^MMB_IP=/ {print $2}' $common_ini`

	# Show Current MMB IP address
	$p $msg240
	printf "$msg241" ; $p $mmb_ip
	echo

	printf "$msg242" ; read "key"
	if [ "$key" != "y" -a "$key" != "Y" ]; then return 1
	fi

	##################
	# Input new MMB IP Address
	##################
	printf "$msg243" ; read "inp_mmb_ip"
	if [ "$inp_mmb_ip" = "" ];then
		$p "$msg245"
		press_enter
		return 1
	fi

	MAX_IP_LEN=16
	inp_num=`echo $inp_mmb_ip | wc -c`
	if [ $inp_num -gt $MAX_IP_LEN ];then
		$p "$msg244"
		press_enter
		return 1
	elif [ $inp_num -le 1 ];then
		$p "$msg245"
		press_enter
		return 1
	elif ! echo $inp_mmb_ip | grep -v "[^0-9.]" >/dev/null 2>&1
	then
		$p "$msg246"
		press_enter
		return 1
	else
		ip1=`echo $inp_mmb_ip | awk -F. '{print $1}'`
		ip2=`echo $inp_mmb_ip | awk -F. '{print $2}'`
		ip3=`echo $inp_mmb_ip | awk -F. '{print $3}'`
		ip4=`echo $inp_mmb_ip | awk -F. '{print $4}'`
		if [ "$ip1" = "" -o "$ip2" = "" -o "$ip3" = "" -o "$ip4" = "" ]; then
			$p "$msg246"
			press_enter
			return 1
		elif [ "$ip1" -gt 255 -o "$ip2" -gt 255 -o "$ip3" -gt 255 -o "$ip4" -gt 255 ]; then
			$p "$msg246"
			press_enter
			return 1
		fi
	fi

	echo
	$p $msg247
	printf "$msg241" ; $p $inp_mmb_ip
	echo
	printf "$msg248" ; read "key"
	if [ "$key" != "y" -a "$key" != "Y" ]; then return 1
	fi

	##################
	# MMB IP Address update
	##################
	src_mmb_ip=`awk /^MMB_IP=/ $common_ini`

	if [ "$com" = "" ]; then
		dst_mmb_ip="MMB_IP=$inp_mmb_ip"
	else
		dst_mmb_ip=`awk /^MMB_IP=/ $common_ini|sed s/$mmb_ip$/$inp_mmb_ip/`
	fi

	# COMMON_INI file update
	tmp="/tmp/hrm_tmp.$$"
	sed s/^"$src_mmb_ip"/$dst_mmb_ip/ < $common_ini > $tmp
	cat $tmp > $common_ini
	rm -f $tmp

	echo
	$p $msg249

	press_enter
	return 0
}

#
# main loop
#
root_check
server_type_check
serverview_rpm_check
while :
do
	check_hrm_process

	#tput clear
	if [ "$server_type" = "SR" ]; then
		banner "$msg007"
	elif [ "$server_type" = "PQ" ]; then
		banner "$msg008"
	else
		banner "$msg001"
	fi
	$p ""
	$p "$msg002"
	show_hrm_status
	$p ""
	$p "$msg011"
	$p "$msg012"
	$p "$msg013"
	$p "$msg014"
	$p "$msg015"
	$p "$msg016"
	$p "$msg017"
	if [ "$server_type" = "PG" -o "$server_type" = "SR" -o "$server_type" = "PQ" ]; then
		$p "$msg018"
		if [ "$server_type" = "SR" -o "$server_type" = "PQ" ]; then
			$p "$msg019"
			if [ "$server_type" = "PQ" ]; then
				$p "$msg020"
			fi
		fi
	fi
	$p "$msg023"
	$p ""
	$p "$msg010""\c"

	need_restart=0
	read num
	case "$num" in
	1)					# enable HRM
		if ask_y_or_n "$msg100"
		then
			touch /var/opt/FJSVhrm/data/hrm_agent_enabled && $p "$msg101"
		fi
		press_enter
		;;
	2)					# disable HRM
		check_hrm_process
		if [ -n "$hrmpid" ]
		then
			$p "$msg104"		# stop HRM before disables
		elif [ -n "$hrmgetpid" -o -n "$fjsvhrmpid" ]
		then
			$p "$msg119"		# stop HRM before disables
		elif ask_y_or_n "$msg102"
		then
			rm -f /var/opt/FJSVhrm/data/hrm_agent_enabled && $p "$msg103"
		fi
		press_enter
		;;
	3)
		check_hrm_process
		if [ ! -f /var/opt/FJSVhrm/data/hrm_agent_enabled ]
		then
			$p "$msg003"			# HRM is disabled
		elif [ -n "$hrmpid" ]
		then
			$p "$msg005"			# HRM is running
		elif [ -n "$hrmgetpid" -o -n "$fjsvhrmpid" ]
		then
			$p "$msg006"			# HRM is starting
		elif ask_y_or_n "$msg111"
		then
			/opt/FJSVhrm/bin/hrmstart >/dev/null
			sleep 5
			$p "$msg113"		# started
		fi
		press_enter
		;;
	4)
		check_hrm_process
		if [ ! -n "$hrmpid" -a ! -n "$hrmgetpid" -a ! -n "$fjsvhrmpid" ]
		then
			$p "$msg004"			# HRM is not running
		else
			if ask_y_or_n "$msg117"
			then
				check_hrm_process
				if [ -n "$fjsvhrmpid" ]
				then
					kill -TERM $fjsvhrmpid >/dev/null 2>&1
				fi
				check_hrm_process
				if [ -n "$hrmgetpid" ]
				then
					kill -TERM $hrmgetpid >/dev/null 2>&1
					sleep 5
				fi
				/opt/FJSVhrm/bin/hrmstop >/dev/null
				sleep 1
				$p "$msg118"
			fi
		fi
		press_enter
		;;
	5)
		#hrm_sdb_menu
		check_hrm_process
		if [ ! -n "$hrmpid" ]
		then
			$p "$msg004"			# HRM is not running
			press_enter
		else
			/opt/FJSVhrm/bin/sdbsetup.pl $sdb_lang
		fi
		;;
	6)
		hrm_security_menu
		;;
	7)
		hrm_snap_menu
		;;
	8)
		hrm_snmp_menu
		;;
	9)
		hrm_statistics_menu
		;;
	10)
		if [ "$server_type" = "PQ" ]; then
			update_mmb_ip
		fi
		;;
	q|Q)
		exit 0
		;;
	esac
done

