#!/bin/sh 

# CLUSTER check
if [ -d /opt/SMAW/bin -a -f /opt/SMAW/bin/hvdisp ]
then
        $HRM_bin/get cluster_status
fi

#
# disk free space check
#
limitsize="50000"				# 50MB
for targ in "/opt" "/var/opt"
do
    avail=`/bin/df -k $targ | /bin/sed -n 2p | /usr/bin/awk '{print $4}'`
    if [ "$avail" != "" ]
    then
        if [ $avail -lt $limitsize ]
        then
             $HRM_bin/hrmevent "W0134:disk space of <<$targ>> is insufficient. (available <<$avail KB>>)"
	fi
    fi
done

#
# cipherproxy check
#
	cipher_path="/opt/FJSVhrmcp/bin/jre/bin/java"
	cipher_status_file="/var/opt/FJSVhrmcp/log/cipherproxy_startstatus.log"
	hrm_pid_file="$HRM_log/sched.pid"
	stathist="$HRM_log/cipherproxy_state"

	hrmpid=`/bin/ps -eo pid,args | /bin/grep -v grep | /bin/grep -w 'hrmsched' | /usr/bin/awk '{print $1}'`
	cippid=`/bin/ps -eo pid,args | /bin/grep -v grep | /bin/grep "$cipher_path" | /usr/bin/awk '{print $1}'`

	cp_status=""
	if [ -n "$cippid" ]
	then
		cp_status="running(pid:$cippid)"
	else
		cp_status="not running"

		if [ "$cipher_status_file" -nt "$hrm_pid_file" ]
		then
			if /bin/grep -i error "$cipher_status_file" >/dev/null
			then
				cp_status="error: `cat $cipher_status_file`"
			fi
		fi
	fi

	echo `/bin/date "+%Y/%m/%d %T "` "$cp_status" >> $stathist
	if [ `/usr/bin/wc -c < $stathist` -gt 1000000 ]
	then
		mv -f $stathist ${stathist}.old
	fi


exit 0

